program argo_stats

use mkinds
use mncio
integer(i4)                     ::  vtype
integer(i4)                     ::  vdim2d(2),vdim1d(1),vdim3d(3)
character(:),allocatable        ::  vname
character(cl)             :: buffer,filebuffer
integer(i4)               :: i,j,k,iunit,ii,jj,n,fid
character(:), allocatable :: f_in,f_out
integer(i4)               :: nx,ny,nz
real(r4),allocatable      :: np(:,:),tmp(:,:,:),lon(:),lat(:)
real(r4),allocatable      :: terr(:,:,:),serr(:,:,:)
real(r4),allocatable      :: mterr(:,:),mserr(:,:)

nx=181
ny=91
nz=52


allocate(terr(nx,ny,nz))
allocate(serr(nx,ny,nz))
allocate(mterr(nx,ny))
allocate(mserr(nx,ny))
allocate(np(nx,ny))
allocate(tmp(nx,ny,nz))
allocate(lon(nx))
allocate(lat(ny))

np=0.0
mterr=0.
mserr=0.

CALL system('ls -1 argo_ts_stats*.nc > list')
     OPEN(15,file="list")
     n=0
     DO
     READ(15,"(A)",END=10) filebuffer
     n=n+1
     ENDDO
10   CONTINUE
     close(15)

OPEN(15,file="list")
do ii=1,n
READ(15,"(A)") filebuffer
f_in=trim(filebuffer)
print *, f_in
call nciopn(f_in,fid)
call nciorv(f_in,fid,"lon",lon)
call nciorv(f_in,fid,"lat",lat)
call nciorv(f_in,fid,"npts",tmp)
call nciorv(f_in,fid,"terr",terr)
call nciorv(f_in,fid,"serr",serr)
call nciocl(f_in,fid)


do j=1,ny
 do i=1,nx
 do k=1,40 
  np(i,j)=np(i,j)+tmp(i,j,k)
  mterr(i,j)=mterr(i,j)+terr(i,j,k)
  mserr(i,j)=mserr(i,j)+serr(i,j,k)
 enddo
 enddo
enddo

enddo

where(np>0.)
        mterr=mterr/np
        mserr=mserr/np
else where
        mterr=2.00**100
        mserr=2.00**100
endwhere





!create file

      f_out="argo_ts_mean.nc"

      call nciocf(f_out,fid)

      !create dimension and coordinate variable 1
      vname="lon"
      vtype=NF90_Float
      vdim1d(1)=1
      call nciodd(f_out,fid,vname,nx)
      call nciocv(f_out,fid,vname,vtype,vdim1d)
      call nciowa(f_out,fid,vname,'long_name','Longitude')
      call nciowa(f_out,fid,vname,'standard_name','Longitude')
      call nciowa(f_out,fid,vname,'units','degrees_east')

      !create dimension and coordinate variable 2
      vname="lat"
      vtype=NF90_Float
      vdim1d(1)=2
      call nciodd(f_out,fid,vname,ny)
      call nciocv(f_out,fid,vname,vtype,vdim1d)
      call nciowa(f_out,fid,vname,'long_name','Latitude')
      call nciowa(f_out,fid,vname,'standard_name','Latitude')
      call nciowa(f_out,fid,vname,'units','degrees_north')

      !create dimension and coordinate variable 2
!      vname="depth"
!      vtype=NF90_Float
!      vdim1d(1)=3
!      call nciodd(f_out,fid,vname,nzlevs)
!      call nciocv(f_out,fid,vname,vtype,vdim1d)
!      call nciowa(f_out,fid,vname,'long_name','depth')
!      call nciowa(f_out,fid,vname,'standard_name','depth')
!      call nciowa(f_out,fid,vname,'units','m')

!create data variable 1
      vname="mterr"
      vtype=NF90_Float
      vdim2d=(/1,2/)
      call nciocv(f_out,fid,vname,vtype,vdim2d)
      call nciowa(f_out,fid,vname,'long_name',"temperature_error")
      call nciowa(f_out,fid,vname,'standard_name',"temperature_error")
      call nciowa(f_out,fid,vname,'_FillValue',2.00**100)

      !create data variable 1
      vname="mserr"
      vtype=NF90_Float
      vdim2d=(/1,2/)
      call nciocv(f_out,fid,vname,vtype,vdim2d)
      call nciowa(f_out,fid,vname,'long_name',"salinity_error")
      call nciowa(f_out,fid,vname,'standard_name',"salinity_error")
      call nciowa(f_out,fid,vname,'_FillValue',2.00**100)

      !create data variable 1
      vname="npts"
      vtype=NF90_Float
      vdim2d=(/1,2/)
      call nciocv(f_out,fid,vname,vtype,vdim2d)
      call nciowa(f_out,fid,vname,'long_name',"number_samples")
      call nciowa(f_out,fid,vname,'standard_name',"number_samples")
      call nciowa(f_out,fid,vname,'_FillValue',2.00**100)
      call ncioed(f_out,fid)

      ! write data into variables
      call nciowv(f_out,fid,"lon",lon)
      call nciowv(f_out,fid,"lat",lat)
!      call nciowv(f_out,fid,"depth",tzlevs)
      call nciowv(f_out,fid,"mterr",mterr)
      call nciowv(f_out,fid,"mserr",mserr)
      call nciowv(f_out,fid,"npts",np)

      ! close file

      call nciocl(f_out,fid)







end program      
