program c2p
use mkinds
use mncio
use mdates
use mabio
use mutil

implicit none

integer(i4),parameter        :: src_nx=2101,src_ny=1537,src_nz=41,src_nt=1
integer(i4),parameter        :: dst_nx=525,dst_ny=385,dst_nz=41,dst_nt=1

character(len=cl)            :: srcFile,dstFile
real(r4),allocatable         :: src_fld(:,:),dst_fld(:,:),depth(:,:)
logical(bl)                  :: lmask(src_nx,src_ny)
integer(i4)                  :: iw(src_nx,src_ny)
real(r4),allocatable         :: src_lon(:),dst_lon(:)
real(r4),allocatable         :: src_lat(:),dst_lat(:),dst_time(:)

integer(i4),allocatable      :: xmap(:,:),ymap(:,:)
! internal variables
integer(i4)                  :: den,i,j,k,l,fid,offset,iif,iil,jjf,jjl,nf,iwp,npass
character(:),allocatable     :: fname,filename,infile,outFile
integer(i4)                  :: vtype,iunit_in,iunit_out
integer(i4)                  :: vdims(4),vdim(1),vdims3(3),vdims2(2)
INTEGER(i4)                  :: ii
INTEGER(i4)                  :: jj
REAL(r4)                     :: ptlon
REAL(r4)                     :: ptlat
REAL(r4)                     :: grdi
REAL(r4)                     :: grdj
REAL(r4)                     :: r
REAL(r4)                     :: s
REAL(r4)                     :: xsum,grdt,val,thbase
REAL(r4),PARAMETER           :: spval=2.00**100
character(8)                 :: cdtg
real(r4)                     :: tstep,mday,sday,hmin,hmax
CHARACTER(len=2)             :: fn
integer(i4)                  :: iyear,iyday,ihour,nleap
character(4)                 :: cyear
character(3)                 :: cday
character(3)                 :: chour
character(4)                 :: clevel
character(22)                :: sflnm
character(:),allocatable     :: mapfile,gomdataloc,gfsdataloc,mwvdataloc
real(r4)                     :: time,atime(1)
character(cl)                :: buffer
CHARACTER(len=80), DIMENSION(2)      :: preambl
CHARACTER(len=80)                    :: cline
character(len=80) :: ctitle(2)
integer(i4) :: yrflag,iversn,sigver,iexpt,nstep
integer(i4)              :: iv1
integer(i4)             :: iv2
real(r4)                 :: rv3
real(r4)                 :: rv4
character(len=8)        :: vname

!bfile headers
!ctitle(1)="CFSR , thermal, precip 3-hrly forcing; LWcorr; PHC3.0 SSS relax;Sigma"
!ctitle(2)="GDEM3 Jan. init; KPP; SeaWiFS KPAR; e-loan ice; A=20; Smag=.05;veldf4=.02;"
!ctitle(3)="S-Z(14-18):dp00/f/x/i=3m/1.18/120m/1m;ds=0.5m/1.18/75m; var den:Med+Black Seas;"
!ctitle(4)="GLBu.08 interpolated to GOMl0.04"

ctitle(1)="RESTART2: iexpt,iversn,yrflag,sigver =     22    22     3     4"
ctitle(2)="RESTART2: nstep,dtime,thbase =      6691320   41820.7500000000 34.0000000000000"

!
iversn=22
iexpt=191
yrflag=3
time=37256.0
nstep=2999100


thbase=34.0
iunit_in=11
iunit_out=12

call getarg(1,buffer)
infile=trim(buffer)

!inFile="restart_out"

call getarg(2,buffer)
outFile=trim(buffer)

!outFile="restart_out_4"


allocate(dst_time(1))
allocate(dst_lon(dst_nx))
allocate(dst_lat(dst_ny))
allocate(src_fld(src_nx,src_ny))
allocate(dst_fld(dst_nx,dst_ny))
allocate(xmap(dst_nx,dst_ny),ymap(dst_nx,dst_ny))
!allocate(depth(dst_nx,src_ny))
dst_time=39813.0

!fname="GLBa0.25.nc"
!CALL  nciopn(fname,fid)
!CALL  nciorv(fname,fid,"depth",depth)
!CALL  nciocl(fname,fid)

call zaiost(src_nx,src_ny)
call zaiopn(infile,iunit_in)

DO 50 i = 1,2
          READ(iunit_in,*)
50  continue

call zbiost(dst_nx,dst_ny)
call zbiopn(trim(outFile),iunit_out)
!write(iunit_out,116) ctitle,iversn,iexpt,yrflag,dst_nx,dst_ny

write(iunit_out,*) "RESTART2: iexpt,iversn,yrflag,sigver =     22    22     3    1"
write(iunit_out,*) "RESTART2: nstep,dtime,thbase =  6691320 41820.7500000000 25.0000000000000 "

!do k=1,424
do k=1,521 !!Alex restart with tides
call zaiord(iunit_in,src_fld,hmin,hmax)
call rdrstbr(iunit_in,iv1,iv2,rv3,rv4,vname)

!nf=3
!npass=0
!iw=0
!do while(npass<4)
!npass=npass+1
!lmask=.true.
!WHERE (src_fld<0.5*spval) iw=1
!print *, "Executing pass no: ", npass, sum(iw)
!WHERE (iw == 0 ) lmask=.false.
!    DO j=1,src_ny
!        jjf=j-nf ; jjl =j+nf
!        jjf=MAX(1,jjf)  ; jjl=MIN(src_ny,jjl)
!      DO i=1,src_nx
!        iif=i-nf ;  iil=i+nf
!        iif=MAX(1,iif)  ; iil=MIN(src_nx,iil)
!        den=SUM(iw(iif:iil,jjf:jjl) )
!      IF ( den /= 0 .and. iw(i,j)==0 ) THEN
!          src_fld(i,j)= SUM(src_fld(iif:iil,jjf:jjl), mask=lmask(iif:iil,jjf:jjl) )/den
!        ENDIF
!      END DO
!    END DO

!enddo
nf=3
lmask=.true.
jj=0
iw=0
WHERE (src_fld<0.5*spval) iw=1
       do j=1,src_ny,4
         ii=0
         jj=jj+1
         jjf=j-nf ; jjl =j+nf
         jjf=MAX(1,jjf)  ; jjl=MIN(src_ny,jjl)
        do i=1,src_nx-1,4
          ii=ii+1
          iif=i-nf ;  iil=i+nf
          iif=MAX(1,iif)  ; iil=MIN(src_nx,iil)
          den=SUM(iw(iif:iil,jjf:jjl) )
        IF ( den /= 0) THEN
          dst_fld(ii,jj)= SUM(src_fld(iif:iil,jjf:jjl),mask=lmask(iif:iil,jjf:jjl) )/den
       else
          dst_fld(ii,jj)=spval
        endif
          enddo
       enddo

       where(dst_fld>1.0e10) dst_fld=spval

call zbiowr(iunit_out,dst_fld,hmin,hmax)
call wrrstbr(iunit_out,iv1,iv2,rv3,rv4,vname)
enddo

call zaiocl(iunit_in)
call zbiocl(iunit_out)

116  format (a80/a80/a80/a80/ &
i5,4x,'''iversn'' = hycom version number x10'/ &
i5,4x,'''iexpt '' = experiment number x10'/    &
i5,4x,'''yrflag'' = days in year flag'/        &
i5,4x,'''idm   '' = longitudinal array size'/  &
i5,4x,'''jdm   '' = latitudinal  array size'/  &
'field       time step  model day','  k  dens        min              max')

117  FORMAT (a8,' =',i11,f11.3,i3,f6.2,2e16.7)
end program c2p

