module maviso
use mkinds
use mdates
use mncio
use mutil
use mgdem
use mgrid
use mhycom
use miotsis
use mpobs
use mprep

contains

subroutine aviso2tsidb(cdtg)

implicit none
character(:),allocatable  :: dt_avisoFile,rt_avisoFile,ncfile,fname
character(10)             :: cdtg,cdtgl
logical(bl)               :: lexist,lrexist,ldexist,dt_aviso,rt_aviso,lmexist
character(3),allocatable  :: altim(:)
integer(i4)               :: fid,naltim,navisoFiles,nob_grp
integer(i4)               :: i,j,ii,jj,ntwin,ncount,ix,jy,ncc
real(r4)                  :: wsday,wday
character(cl),allocatable :: avisoFiles(:)
logical(bl)               :: lobs
real(r4),allocatable      :: work(:,:),mdt(:,:),err(:,:)                  
integer(i4),allocatable   :: idx(:,:),ob_grp_present(:)
real(r4)                  :: il,jl,js,je
integer(i4),parameter     :: igdm=1440,jgdm=720
real(r4)                  :: uc,vc,cc,ptlon,ptlat
real(r4),allocatable      :: gm_sla(:,:),lm_sla(:,:),gm_lon(:),gm_lat(:),lm_sla_err(:,:),gm_sla_err(:,:)
real(r4),allocatable      :: gm_uc(:,:),lm_uc(:,:)
real(r4),allocatable      :: gm_vc(:,:),lm_vc(:,:)
!model info
character(len=20)         :: model,fcst_file,anl_file
logical(bl)               :: lglb,fcst_file_out
character(len=5)          :: pfx
real(r4),parameter        :: spval=2.00**100
NAMELIST/model_info/model,sigver,lglb,fcst_file,anl_file,fcst_file_out,pfx


nob_grp=4
allocate(ob_grp_present(nob_grp))

naltim=13
allocate(altim(naltim))

altim=['en','g2','j1','j1n','j1g','j2','j2n','j2g','al','alg','c2','j3','s3a']

! analysis date

!call getarg(1,cdtg)
call CDATE2WNDAY(WDAY,cdtg)
!call initialize_analysis_grid()
!call read_obs_location()
!call read_obs_window()
call read_prep_params()
call set_obs_grid_bounds(start,count,cdtg)
call initialize_obs_vector()
OPEN(21,FILE='tsis.nlist')
READ(21,NML=model_info)
CLOSE(21)

ntwin=(twin_end-twin_start)+1
navisoFiles=naltim*ntwin
allocate(avisoFiles(navisoFiles))
navisoFiles=0

do jj=twin_start,twin_end
  wsday=wday+real(jj,r4)
    call wday2cdate(wsday,cdtgl)

  do ii=1,naltim

   dt_avisoFile=trim(at_sla_data_location)//trim(altim(ii))//"/dt_global_"//trim(altim(ii))//"_phy_vfec_l3_"//cdtgl(1:8)//".nc.gz"
   rt_avisoFile=trim(at_sla_data_location)//trim(altim(ii))//"/nrt_global_"//trim(altim(ii))//"_phy_vfec_l3_"//cdtgl(1:8)//".nc.gz"
   
   INQUIRE(FILE=dt_avisoFile, EXIST=ldexist)
   INQUIRE(FILE=rt_avisoFile, EXIST=lrexist)

   if(ldexist) then
        navisoFiles=navisoFiles+1   
        avisoFiles(navisoFiles)=dt_avisoFile
   endif

   dt_aviso = ldexist 
   rt_aviso = lrexist .and. (.not. dt_aviso)

   if (dt_aviso) then
     !   print *, "delayed time files available"
     !   print *, " will use the foll files: "
     !do i=1,navisoFiles
     !print *, avisoFiles(navisoFiles)
     !enddo
     
   endif
   if (rt_aviso) then
        print *, "delayed time files not available but real-time file present"
        navisoFiles=navisoFiles+1
        avisoFiles(navisoFiles)=rt_avisoFile 
  
  endif
 enddo
enddo

if(navisoFiles>1) then

if (allocated(work_obs)) deallocate(work_obs)
allocate(work_obs(mxobs))
if (allocated(obs)) deallocate(obs)
allocate(work(nx,ny),mdt(nx,ny),idx(nx,ny),err(nx,ny))
!allocate(lon1d(nx),lat1d(ny))

! read mdt
fname="mdt.nc"
call nciopn(fname,fid)
call nciorv(fname,fid,"mdt",mdt)
call nciocl(fname,fid)

ncount=0
nobs=0

!call get_test_obs(obsdb,lonbnds,latbnds,timebnds,work_obs,ncount,0.04,lobs)
! try j2
!obsdb=trim(at_sla_data_location)//"tsidb_nrt_sla_j2n_"//cdtg(1:4)//".nc"
!obsdb=trim(sla_data_location)//"tsidb_sla_j2_"//cdate(1:4)//".nc"
!CALL getobs(obsdb,lonbnds,latbnds,timebnds,work_obs,ncount,0.04,lobs)
!write(*,*)  "Using the following aviso files: "
    do ii=1,navisoFiles
!     print *, trim(avisoFiles(ii))
     call system('gunzip '//avisoFiles(ii)(1:len_trim(avisoFiles(ii))))
     ncfile=avisoFiles(ii)(1:len_trim(avisoFiles(ii))-3)
     CALL getobs(ncfile,lonbnds,latbnds,timebnds,work_obs,ncount,0.04,lobs)
     call system('gzip '//avisoFiles(ii)(1:len_trim(avisoFiles(ii))-3))
!    write(*,*), "Filename: ",ncfile, "No of Observations: ",ncount
    enddo

work=0.0


work=2.00**100
do i=1,ncount
if(work_obs(i)%lon>180.0) work_obs(i)%lon=work_obs(i)%lon-360.0
  if(lglb) then
  call lon_lat_idx(mlon,mlat,nx,ny,work_obs(i)%lon,work_obs(i)%lat,lglb,il,jl)
  ii=int(il)
  jj=int(jl)
  else
  ii=ridx(mlon(:,1),work_obs(i)%lon)
  jj=ridx(mlat(1,:),work_obs(i)%lat)
  endif
!!Alex  work(ii,jj)=work_obs(i)%val+mdt(ii,jj)
 work(ii,jj)=work_obs(i)%val
  err(ii,jj)=work_obs(i)%err
  idx(ii,jj)=1.0
  !print *, i,ii,jj,work_obs(i)%val,work(ii,jj)
enddo

write(*,*) "Total no of SLA observations points: ",ncount
write(*,*) "No of binned SLA observations points: ",sum(idx)

fname=trim(tsis_obs_location)//"tsis_obs_"//trim(pfx)//"_"//cdtg//".nc"
!fname="tsis_obs_"//cdtg//".nc"
call nciopn(fname,fid)
call nciowv(fname,fid,"ssh",work)
call nciowv(fname,fid,"ssh_err",err)
call nciorv(fname,fid,"ob_grp_present",ob_grp_present)
ob_grp_present(2)=1
call nciowv(fname,fid,"ob_grp_present",ob_grp_present)
call nciocl(fname,fid)


endif ! aviso files present


!ncfile="ssh_obs_"//cdtg//".nc"
!call ncfldio(ncfile,mlon(:,1),mlat(1,:),mlayer,stime(1),work,"fssh","sea surface deviation from mean","m",nx,ny,1,1)

! prepare mapped aviso files
fname=trim(sla_data_location)//"nrt_global_allsat_phy_l4_"//cdtg(1:8)//".nc"
 INQUIRE(FILE=fname, EXIST=lmexist)
 if(lmexist) then
print *, fname
allocate(gm_lon(igdm),gm_lat(jgdm))
allocate(gm_sla(igdm,jgdm))
allocate(gm_sla_err(igdm,jgdm))
allocate(gm_uc(igdm,jgdm))
allocate(gm_vc(igdm,jgdm))
allocate(lm_sla(nx,ny))
allocate(lm_sla_err(nx,ny))
allocate(lm_uc(nx,ny))
allocate(lm_vc(nx,ny))

call nciopn(fname,fid)
call nciorv(fname,fid,"longitude",gm_lon)
call nciorv(fname,fid,"latitude",gm_lat)
call nciorv(fname,fid,"sla",gm_sla)
call nciorv(fname,fid,"err",gm_sla_err)
call nciorv(fname,fid,"ugos",gm_uc)
call nciorv(fname,fid,"vgos",gm_vc)
call nciocl(fname,fid)

where(gm_sla>-2147483647.) 
        gm_sla=gm_sla*0.0001
        gm_sla_err=gm_sla_err*0.0001
else where
        gm_sla=spval
        gm_sla_err=spval
end where

where(gm_uc>-2147483647. .and. gm_vc>-2147483647.)
        gm_uc=gm_uc*0.0001
        gm_vc=gm_vc*0.0001
else where
        gm_uc=spval
        gm_vc=spval
end where








write(*,*) "UGOS min, max: ", minval(gm_uc,mask=gm_uc<spval),maxval(gm_uc,mask=gm_uc<spval)
write(*,*) "VGOS min, max: ",minval(gm_vc,mask=gm_vc<spval),maxval(gm_vc,mask=gm_vc<spval)

lm_uc=spval
lm_vc=spval

ncc=0
do j=1,ny
 do i=1,nx
  if(mdepth(i,j)<spval) then
          ptlon=mlon(i,j)+360.0
          ptlat=mlat(i,j)
          ix=nint(ridx(gm_lon,ptlon))
          jy=nint(ridx(gm_lat,ptlat))
          uc=gm_uc(ix,jy)
          vc=gm_vc(ix,jy)
          cc=sqrt(uc*uc+vc*vc)
          if(cc>0.5) then
            lm_uc(i,j)=uc
            lm_vc(i,j)=vc
            ncc=ncc+1
          endif      
  endif
enddo
enddo

write(*,*) "No of Vel Obs: ", ncc



call ifld(igdm,jgdm,nx,ny,gm_lon,gm_lat,gm_sla,gm_sla_err,lm_sla,lm_sla_err)
where(abs(lm_sla)>2.0) lm_sla=spval
where(abs(lm_sla_err)>2.0) lm_sla_err=spval        
write(*,*) "SLA min, max: ", minval(lm_sla,mask=lm_sla<spval), maxval(lm_sla,mask=lm_sla<spval)
write(*,*) "SLA err min, max: ",minval(lm_sla_err,mask=lm_sla<spval), maxval(lm_sla_err,mask=lm_sla<spval)

lm_sla=lm_sla+mdt

if(lglb) then
         js=ridx(mlat(1,:),-46.0)
         je=ridx(mlat(1,:),46.0)
         lm_sla(:,1:js-1)=2.00**100
         lm_sla(:,je+1:ny)=2.00**100
endif
where(abs(lm_sla)>2.5) lm_sla=2.00**100


fname=trim(tsis_obs_location)//"tsis_obs_"//trim(pfx)//"_"//cdtg//".nc"
call nciopn(fname,fid)
call nciowv(fname,fid,"av_ssh",lm_sla)
call nciowv(fname,fid,"av_ssh_err",lm_sla_err)
call nciowv(fname,fid,"uc",lm_uc)
call nciowv(fname,fid,"vc",lm_vc)
call nciorv(fname,fid,"ob_grp_present",ob_grp_present)
ob_grp_present(4)=1
call nciowv(fname,fid,"ob_grp_present",ob_grp_present)
call nciocl(fname,fid)
endif


!open(unit=10,file="sla.txt",status="unknown")    
!    do ii=1,ncount,5
!      write(10,'(5F12.4)'), work_obs(ii)%lon,work_obs(ii)%lat,work_obs(ii)%time,work_obs(ii)%val
!    enddo
!close(10)
end subroutine



end module maviso      
