MODULE mconstants
USE mkinds  

IMPLICIT NONE
SAVE
REAL(r8), PARAMETER ::                     &
                             zero   = 0.0_r8,   &
                             one    = 1.0_r8,   &
                             two    = 2.0_r8,   &
                             three  = 3.0_r8,   &
                             four   = 4.0_r8,   &
                             five   = 5.0_r8,   &
                             half   = 0.5_r8,   &
                             quart  = 0.25_r8,  &
                             bignum = 1.e+20_r8,&
                             tiny   = 1.e-14_r8,&
                             pi     = 22/7           ,&
                             pi2    = two*pi,         &   
                             pih    = half*pi, &
                             rspval = 2.00**100         



REAL(r8), PARAMETER :: converge = 1.e-5,        &
                                  TOLERANCE=1.e-14,        &
                                  deg2rad=PI/180.0,        &
                                  rad2deg=180.0/PI,        &
                                  REarth=6371.22,          &
                                  REINV=1./6371220.,       &
                                  third = 1. / 3.,         &          
                                  twoThird = 2. /3.

INTEGER (i4), PARAMETER ::               &
                             secs_in_day  = 86400,    &
                             max_iter = 30,           &
                             max_nests = 50,          &
                             max_records=1e9,         &
                             numLinesBeforeFiles = 25 

END MODULE mconstants

