MODULE mens
USE mkinds
USE mncio
USE mutil
USE mdates
USE mspmd, only : pid


IMPLICIT NONE

TYPE t_ens
REAL(r4),allocatable       :: ssh(:,:,:)
REAL(r4),allocatable       :: sst(:,:,:)
REAL(r4),allocatable       :: uvl(:,:,:,:)
REAL(r4),allocatable       :: vvl(:,:,:,:)
REAL(r4),allocatable       :: tem(:,:,:)
REAL(r4),allocatable       :: sal(:,:,:)
REAL(r4),allocatable       :: thk(:,:,:,:)
REAL(r4),allocatable       :: den(:,:,:,:)
REAL(r4),allocatable       :: var(:,:,:,:)
REAL(r4),allocatable       :: var2d(:,:,:)
REAL(r4),allocatable       :: var2d1(:,:,:)
REAL(r4),allocatable       :: tmp(:,:,:,:)
real(r4),allocatable       :: enslon(:)
real(r4),allocatable       :: enslat(:)
INTEGER(i4)                :: nmembers
INTEGER(i4)                :: ntotalmembers
INTEGER(i4)                :: ens_nx
INTEGER(i4)                :: ens_ny
INTEGER(i4)                :: ens_nz
CHARACTER(cl)              :: ensLoc
CHARACTER(cl)              :: enslist
INTEGER(i4),allocatable    :: usedmems(:)
END TYPE

type(t_ens)                :: ens
type(t_ens)                :: enspt

INTEGER(i4)                :: nmembers
INTEGER(i4)                :: ntotalmembers
INTEGER(i4)                :: ens_nx
INTEGER(i4)                :: ens_ny
INTEGER(i4)                :: ens_nz
CHARACTER(cl)              :: ensLoc
CHARACTER(cl)              :: enslist
real(r4),allocatable      ::  tem_std(:,:,:)
real(r4),allocatable      ::  sal_std(:,:,:)
real(r4),allocatable      ::  pin_std(:,:,:)
real(r4),allocatable      ::  ssh_std(:,:)


CONTAINS

SUBROUTINE getEnsInfo(ensLoc,enslist,ntotalmembers,ens_nx,ens_ny,ens_nz)

        implicit none
        integer(i4)                :: ntotalmembers
        integer(i4)                :: ens_nx,ens_ny,ens_nz
        character(cl)              :: ensLoc
        character(cl)              :: enslist

        NAMELIST /ensnml/ensLoc,enslist,ntotalmembers,ens_nx,ens_ny,ens_nz
        ! read location and number of members to initialize the namelist
        OPEN(21,FILE='tsis.nlist')
        READ(21,NML=ensnml)
        CLOSE(21)

END SUBROUTINE

SUBROUTINE ensmems(cdtg)
!returns the members to use from the enslist file
!the files to be used are marked with 1's in the 
!usedmems array. 

character(*)              :: cdtg
real(r4)                  :: tstep,mday
CHARACTER(len=2)          :: fn
integer(i4)               :: n,i,l,iyear,iyday,ihour,dmin,dmax,dday
character(4)              :: cyear
character(3)              :: cday
character(3)              :: chour
character(cl)             :: fname
real(r4)                  :: time,level
integer(i4)               :: winl,ntotalmembers
character(:),allocatable  :: Fenslist

n=0
winl=45 ! set running window length

!call getEnsInfo(ens%ensloc,ens%enslist,ens%ntotalmembers)
Fenslist=trim(ens%enslist)
ntotalmembers=ens%ntotalmembers
allocate(ens%usedmems(ntotalmembers))
ens%usedmems=0
!print *, Fenslist,ntotalmembers
call CDATE2WNDAY(mday,cdtg)
call forday(mday,iyear,iyday,ihour)

dmin=iyday-winl
dmax=iyday+winl

if(dmin<=0) then
  dmin=365+dmin
  dmax=365
! do upto 365
  open(31,FILE=Fenslist,action="read")
  do i=1,ntotalmembers
    read(31,*) fname
     read (fname(10:12),*) dday
       if(dday>dmin .and. dday<dmax) then
         n=n+1
         ens%usedmems(i)=1
         !print *,n,iyday,dmin,dday,dmax
     endif
   enddo

   dmin=0
   dmax=iyday+winl
   rewind(31)
   open(31,FILE=Fenslist,action="read")
   do i=1,ntotalmembers
   read(31,*) fname
   read (fname(10:12),*) dday
     if(dday>dmin .and. dday<dmax) then
         n=n+1
         ens%usedmems(i)=1
!         print *,n,iyday,dmin,dday,dmax
     endif
     enddo

else if (dmax>=365) then
   dmax=365
     ! do upto 365
     rewind(31)
  open(31,FILE=Fenslist,action="read")
  do i=1,ntotalmembers
    read(31,*) fname
     read (fname(10:12),*) dday
        if(dday>dmin .and. dday<dmax) then
         n=n+1
         ens%usedmems(i)=1
!         print *,n,iyday,dmin,dday,dmax
     endif
   enddo

   dmin=0
   dmax=iyday+winl-365
   rewind(31)
   open(31,FILE=Fenslist,action="read")
  do i=1,ntotalmembers
    read(31,*) fname
     read (fname(10:12),*) dday
        if(dday>dmin .and. dday<dmax) then
         n=n+1
         ens%usedmems(i)=1
!         print *,n,iyday,dmin,dday,dmax
     endif
   enddo
else
        rewind(31)
   open(31,FILE=Fenslist,action="read")
  do i=1,ntotalmembers
    read(31,*) fname
     read (fname(10:12),*) dday
        if(dday>dmin .and. dday<dmax) then
         n=n+1
         ens%usedmems(i)=1
!         print *,n,iyday,dmin,dday,dmax
     endif
   enddo

endif
rewind(31)

ens%nmembers=n
!do i=1,ntotalmembers
!    read(31,*) fname
!    if(ens%usedmems(i)==1) then
!     print *, trim(fname)
!    endif
!enddo
close(31)

END subroutine

SUBROUTINE init_stat(pfx)
IMPLICIT NONE
character(len=*)           :: pfx
integer(i4)                :: fid
character(:),allocatable   :: filename

call getEnsInfo(ensLoc,enslist,ntotalmembers,ens_nx,ens_ny,ens_nz)
filename=trim(ensLOC)//"tops_"//trim(pfx)//"_std.nc"


allocate(tem_std(ens_nx,ens_ny,1))
allocate(sal_std(ens_nx,ens_ny,1))
allocate(pin_std(ens_nx,ens_ny,1))
allocate(ssh_std(ens_nx,ens_ny))


END Subroutine

subroutine get_varb(pfx,var,varb,k)
implicit none
character(len=*)           :: pfx
character(len=*) :: var
real(r4)         :: varb(:,:,:),vscal
integer(i4)      :: k
integer(i4)                :: fid
character(:),allocatable   :: filename
vscal=1.0
filename=trim(ensLOC)//"tops_"//trim(pfx)//"_std.nc"
if(var=="ssh") then
        call nciopn(filename,fid)
        call nciorv(filename,fid,"ssh",ssh_std)
        call nciocl(filename,fid)
!         ssh_std=0.20
        varb(:,:,1)=vscal*ssh_std

else if( var=="tem") then
        call nciopn(filename,fid)
        call nciorv(filename,fid,"tem",tem_std,[1,1,k],[ens_nx,ens_ny,1])
        call nciocl(filename,fid)
!         tem_std(:,:,1)=0.5
        varb(:,:,1)=vscal*tem_std(:,:,1)
else if(var=="sal") then 
        call nciopn(filename,fid)
        call nciorv(filename,fid,"sal",sal_std,[1,1,k],[ens_nx,ens_ny,1])
        call nciocl(filename,fid)
!         sal_std(:,:,1)=0.2
        varb(:,:,1)=vscal*sal_std(:,:,1)
else if( var=="pin") then
        call nciopn(filename,fid)
        call nciorv(filename,fid,"pin",pin_std,[1,1,k],[ens_nx,ens_ny,1])
        call nciocl(filename,fid) 
!         pin_std(:,:,1)=30.0
         varb(:,:,1)=vscal*pin_std(:,:,1)
else if(var=="uvp") then
       filename=trim(ensLOC)//"tops_"//trim(pfx)//"_uvp.nc"
       call nciopn(filename,fid)
       call nciorv(filename,fid,"muba",varb(:,:,1),[1,1,k],[ens_nx,ens_ny,1])
       call nciorv(filename,fid,"mvba",varb(:,:,2),[1,1,k],[ens_nx,ens_ny,1])
       call nciorv(filename,fid,"mssh",varb(:,:,3),[1,1,k],[ens_nx,ens_ny,1])
       call nciocl(filename,fid)
        varb=vscal*varb
endif

end subroutine
SUBROUTINE initEns2d(ens,cdtg)
IMPLICIT NONE
TYPE(t_ens)           :: ens
CHARACTER(cl)         :: ensLoc
INTEGER(i4)           :: kfp,klp
INTEGER(i4)           :: ifp,ilp
INTEGER(i4)           :: jfp,jlp
character(*)          :: cdtg

call getEnsInfo(ens%ensloc,ens%enslist,ens%ntotalmembers,ens%ens_nx,ens%ens_ny,ens%ens_nz)
call ensmems(cdtg)

allocate(ens%enslon(ens%ens_nx), ens%enslat(ens%ens_ny))
allocate(ens%var2d(ens%ens_nx,ens%ens_ny,ens%nmembers))
allocate(ens%var2d1(ens%ens_nx,ens%ens_ny,ens%nmembers))

if(pid==0) write(*,*) "....initialized and loaded   ", ens%nmembers, "cvects"
if(pid==0) Write(*,*) "....in memory ens size (GB)....", 2.0*size(ens%var2d)*4./1024./1024./1024.
END SUBROUTINE

SUBROUTINE loadEns2d(ens,var,k,m)
type(t_ens)            :: ens
INTEGER(i4)            :: i,j,k,l,m
CHARACTER(Len=cl)      :: FileName
INTEGER(i4)            :: fid
CHARACTER(Len=cl)      :: PathFileName
REAL(r4),ALLOCATABLE   :: tmp(:,:,:)
INTEGER(i4)            :: nt
character(len=*)       :: var


IF(m==0) then
if(allocated(tmp)) deallocate(tmp)
allocate(tmp(ens%ens_nx,ens%ens_ny,1))
nt=ens%nmembers
j=0
open(31,FILE=trim(ens%enslist),action="read")
do i=1,ens%ntotalmembers
   read(31,*) FileName
 PathFileName=trim(ens%ensLoc)//"/"//trim(FileName)
 if(ens%usedmems(i)==1) then
         j=j+1
   CALL nciopn(trim(PathFileName),fid)
   if(j==1) then
     CALL nciorv(trim(PathFileName),fid,"lon",ens%enslon)
     CALL nciorv(trim(PathFileName),fid,"lat",ens%enslat)
   endif
   if(var=="ssh") then    
     CALL nciorv(trim(PathFileName),fid,"mssh",ens%var2d(:,:,j))
   else if(var=="sst") then
     CALL nciorv(trim(PathFileName),fid,"msst",ens%var2d(:,:,j))
   else if(var=="sss") then
     CALL nciorv(trim(PathFileName),fid,"msss",ens%var2d(:,:,j))
   else if(var=="tem") then  
     CALL nciorv(trim(PathFileName),fid,"mtem",tmp,[1,1,k],[ens%ens_nx,ens%ens_ny,1])
     ens%var2d(:,:,j)=tmp(:,:,1)
   else if(var=="sal") then
     CALL nciorv(trim(PathFileName),fid,"mtem",tmp,[1,1,k],[ens%ens_nx,ens%ens_ny,1])
     ens%var2d(:,:,j)=tmp(:,:,1)
   else if(var=="pin") then
     CALL nciorv(trim(PathFileName),fid,"mpin",tmp,[1,1,k],[ens%ens_nx,ens%ens_ny,1])
     ens%var2d(:,:,j)=tmp(:,:,1)
   else if(var=="uvl") then
     CALL nciorv(trim(PathFileName),fid,"muvl",tmp,[1,1,k],[ens%ens_nx,ens%ens_ny,1])
     ens%var2d(:,:,j)=tmp(:,:,1)
   else if(var=="vvl") then
     CALL nciorv(trim(PathFileName),fid,"mvvl",tmp,[1,1,k],[ens%ens_nx,ens%ens_ny,1])
     ens%var2d(:,:,j)=tmp(:,:,1) 
   endif                  ! var
   CALL nciocl(trim(PathFileName),fid)
   !print *, trim(FileName),ens%var2d(260,200,j)
   endif
ENDDO
close(31)

ELSE if( m==1) then
if(allocated(tmp)) deallocate(tmp)
allocate(tmp(ens%ens_nx,ens%ens_ny,1))
nt=ens%nmembers
j=0
open(31,FILE=trim(ens%enslist),action="read")
do i=1,ens%ntotalmembers
   read(31,*) FileName
 PathFileName=trim(ens%ensLoc)//"/"//trim(FileName)
 if(ens%usedmems(i)==1) then
         j=j+1
   CALL nciopn(trim(PathFileName),fid)
   if(j==1) then
     CALL nciorv(trim(PathFileName),fid,"lon",ens%enslon)
     CALL nciorv(trim(PathFileName),fid,"lat",ens%enslat)
   endif
   if(var=="ssh") then
     CALL nciorv(trim(PathFileName),fid,"mssh",ens%var2d1(:,:,j))
   else if(var=="sst") then
     CALL nciorv(trim(PathFileName),fid,"msst",ens%var2d1(:,:,j))
   else if(var=="sss") then
     CALL nciorv(trim(PathFileName),fid,"msss",ens%var2d1(:,:,j))
   else if(var=="tem") then
     CALL nciorv(trim(PathFileName),fid,"mtem",tmp,[1,1,k],[ens%ens_nx,ens%ens_ny,1])
     ens%var2d1(:,:,j)=tmp(:,:,1)
   else if(var=="sal") then
     CALL nciorv(trim(PathFileName),fid,"mtem",tmp,[1,1,k],[ens%ens_nx,ens%ens_ny,1])
     ens%var2d1(:,:,j)=tmp(:,:,1)
   else if(var=="pin") then
     CALL nciorv(trim(PathFileName),fid,"mpin",tmp,[1,1,k],[ens%ens_nx,ens%ens_ny,1])
     ens%var2d1(:,:,j)=tmp(:,:,1)
   else if(var=="thk") then
     CALL nciorv(trim(PathFileName),fid,"mthk",tmp,[1,1,k],[ens%ens_nx,ens%ens_ny,1])
     ens%var2d1(:,:,j)=tmp(:,:,1) 
   else if(var=="uvl") then
     CALL nciorv(trim(PathFileName),fid,"muvl",tmp,[1,1,k],[ens%ens_nx,ens%ens_ny,1])
     ens%var2d1(:,:,j)=tmp(:,:,1)
   else if(var=="vvl") then
     CALL nciorv(trim(PathFileName),fid,"mvvl",tmp,[1,1,k],[ens%ens_nx,ens%ens_ny,1])
     ens%var2d1(:,:,j)=tmp(:,:,1)
!   print *, j,trim(FileName),ens%var2d1(250,200,j)
   endif                  ! var
   CALL nciocl(trim(PathFileName),fid)
  endif
ENDDO
close(31)

ENDIF ! m 0 or 1        

!if(pid==0) write(*,*) "....initialized and loaded   ", j, "cvects"
!if(pid==0) Write(*,*) "....in memory ens size (GB)....", 2.0*size(ens%var2d)*4./1024./1024./1024.

END SUBROUTINE


SUBROUTINE FreeEns2d(ens)
IMPLICIT NONE
TYPE(t_ens)           :: ens
INTEGER(i4)           :: start(3)
INTEGER(i4)           :: count(3)
CHARACTER(cl)         :: ensLoc
INTEGER(i4)           :: kfp,klp
INTEGER(i4)           :: ifp,ilp
INTEGER(i4)           :: jfp,jlp
deallocate(ens%usedmems)
deallocate(ens%ssh,ens%sst)
END SUBROUTINE

SUBROUTINE initEns3dvar(ens,start,count,cdtg)
IMPLICIT NONE
TYPE(t_ens)           :: ens
INTEGER(i4)           :: start(3)
INTEGER(i4)           :: count(3)
CHARACTER(cl)         :: ensLoc
INTEGER(i4)           :: kfp,klp
INTEGER(i4)           :: ifp,ilp
INTEGER(i4)           :: jfp,jlp
character(*)          :: cdtg

ens%ens_nx=count(1)
ens%ens_ny=count(2)
ens%ens_nz=count(3)

call ensmems(cdtg)
! simultaneously allocate 1d version
!enspt%nx=1
!enspt%ny=1
!enspt%nz=count(3)
!enspt%nmembers=ens%nmembers
allocate(ens%var(count(1),count(2),count(3),ens%nmembers))
if(pid==0) Write(*,*) "....in memory ens size (GB)....", 2.0*size(ens%var)*4./1024./1024./1024.
END SUBROUTINE

SUBROUTINE loadEns3dvar(ens, start,count,var)
type(t_ens)            :: ens
INTEGER(i4)            :: start(3)
INTEGER(i4)            :: count(3)
INTEGER(i4)            :: i,j,k,l
CHARACTER(Len=cl)      :: FileName
INTEGER(i4)            :: fid
CHARACTER(Len=cl)      :: PathFileName
REAL(r4),ALLOCATABLE   :: mvar(:,:,:)
INTEGER(i4)            :: nt
character(3)           :: var

nt=ens%nmembers
!ALLOCATE(mvar(count(1),count(2),count(3)))
if(allocated(ens%tmp)) deallocate(ens%tmp)
allocate(ens%tmp(count(1),count(2),count(3),ens%nmembers))
j=0
open(31,FILE=trim(ens%enslist),action="read")
do i=1,ens%ntotalmembers
   read(31,*) FileName
 PathFileName=trim(ens%ensLoc)//"/"//trim(FileName)
 if(ens%usedmems(i)==1) then
         j=j+1
   CALL nciopn(trim(PathFileName),fid)
   if(var .eq. "tem") then
    CALL nciorv(trim(PathFileName),fid,"tem",ens%var(:,:,:,j))
   else if(var .eq. "sal") then
    CALL nciorv(trim(PathFileName),fid,"sal",ens%var(:,:,:,j))
   else if(var .eq. "den") then
    CALL nciorv(trim(PathFileName),fid,"den",ens%var(:,:,:,j))
   else if(var .eq. "thk") then
   CALL nciorv(trim(PathFileName),fid,"thk",ens%tmp(:,:,:,j))
    ens%var(:,:,1,j)=0.0
    do k=2,count(3)
      ens%var(:,:,k,j)=ens%var(:,:,k-1,j)+ens%tmp(:,:,k,j)/9806.
      !print *, ens%tmp(250,200,k,j),ens%var(250,200,k,j)
    enddo
   endif
   CALL nciocl(trim(PathFileName),fid)
   endif
ENDDO
close(31)
if(pid==0) write(*,*) "....loaded   ", j," ", var, " cvects"
END SUBROUTINE

SUBROUTINE FreeEns3dvar(ens)
IMPLICIT NONE
TYPE(t_ens)           :: ens
  deallocate(ens%usedmems)
  deallocate(ens%var)
END SUBROUTINE

SUBROUTINE initEnsUVDP(ens,start,count,cdtg)
        IMPLICIT NONE
        TYPE(t_ens)           :: ens
        INTEGER(i4)           :: start(3)
        INTEGER(i4)           :: count(3)
        CHARACTER(cl)         :: ensLoc
        INTEGER(i4)           :: kfp,klp
        INTEGER(i4)           :: ifp,ilp
        INTEGER(i4)           :: jfp,jlp
        character(*)          :: cdtg

        ens%ens_nx=count(1)
        ens%ens_ny=count(2)
        ens%ens_nz=count(3)
        call ensmems(cdtg)
        allocate(ens%uvl(count(1),count(2),count(3),ens%nmembers))
        allocate(ens%vvl(count(1),count(2),count(3),ens%nmembers))
        allocate(ens%thk(count(1),count(2),count(3),ens%nmembers))
        if(pid==0) Write(*,*) "....in memory ens size (GB)....", 3.0*size(ens%uvl)*4./1024./1024./1024.
END SUBROUTINE

SUBROUTINE FreeEnsUVDP(ens)
IMPLICIT NONE
TYPE(t_ens)           :: ens
   deallocate(ens%var)
END SUBROUTINE


SUBROUTINE loadMemsUVDP(ens, start,count)
type(t_ens)            :: ens
INTEGER(i4)            :: start(3)
INTEGER(i4)            :: count(3)
INTEGER(i4)            :: i,j,k,l
CHARACTER(Len=cl)      :: FileName
INTEGER(i4)            :: fid
CHARACTER(Len=cl)      :: PathFileName
REAL(r4),ALLOCATABLE   :: muvl(:,:,:),mvvl(:,:,:),mthk(:,:,:)
INTEGER(i4)            :: nt

nt=ens%nmembers

ALLOCATE(muvl(count(1),count(2),count(3)))
ALLOCATE(mvvl(count(1),count(2),count(3)))
ALLOCATE(mthk(count(1),count(2),count(3)))

j=0
open(31,FILE=trim(ens%enslist),action="read")
do i=1,ens%ntotalmembers
   read(31,*) FileName
 PathFileName=trim(ens%ensLoc)//"/"//trim(FileName)
 if(ens%usedmems(i)==1) then
         j=j+1
   CALL nciopn(trim(PathFileName),fid)
   CALL nciorv(trim(PathFileName),fid,"uvl",ens%uvl(:,:,:,j))
   CALL nciorv(trim(PathFileName),fid,"vvl",ens%vvl(:,:,:,j))
   CALL nciorv(trim(PathFileName),fid,"thk",ens%thk(:,:,:,j))
   CALL nciocl(trim(PathFileName),fid)
  endif

ENDDO
close(31)
if(pid==0) write(*,*) "....initialized and loaded   ", j, "cvects"
if(pid==0) Write(*,*) "....in memory ens size (GB)....", 3.0*size(ens%uvl)*4./1024./1024./1024.

!calculate anomalies
muvl=sum(ens%uvl,4)/size(ens%uvl,4)
mvvl=sum(ens%vvl,4)/size(ens%vvl,4)
mthk=sum(ens%thk,4)/size(ens%thk,4)

! remove mean
do l=1,nt
 do k=1,count(3)
  do j=1,count(2)
   do i=1,count(1)
ens%uvl(i,j,k,l)=ens%uvl(i,j,k,l)-muvl(i,j,k)
ens%vvl(i,j,k,l)=ens%vvl(i,j,k,l)-mvvl(i,j,k)
ens%thk(i,j,k,l)=ens%thk(i,j,k,l)-mthk(i,j,k)
     enddo
   enddo
 enddo
enddo

DEALLOCATE(muvl,mvvl,mthk)
END SUBROUTINE

REAL(r4) FUNCTION ensmean(mlon,mlat,ens,var,ptlon,ptlat,lyr)
IMPLICIT NONE
REAL(r4)          :: mlon(:,:)
REAL(r4)          :: mlat(:,:)
TYPE(t_ens)       :: ens
CHARACTER(Len=*)  :: var
REAL(r4)          :: ptlon
REAL(r4)          :: ptlat
INTEGER(i4)       :: lyr

REAL(r4)          :: iindx
REAL(r4)          :: jindx
REAL(r4), allocatable :: ival(:)
INTEGER(i4)       :: k

allocate(ival(ens%nmembers))
iindx=ridx(mlon(:,1),ptlon)
jindx=ridx(mlat(1,:),ptlat)

call ensInterp(ens,var,iindx,jindx,lyr,ival)
call com_mean(ens%nmembers,ival,ensmean)
deallocate(ival)

return
END FUNCTION

REAL(r4) FUNCTION ensmeanij(ens,var,xi,yj,lyr)
IMPLICIT NONE
TYPE(t_ens)       :: ens
CHARACTER(Len=*)  :: var
REAL(r4)          :: xi
REAL(r4)          :: yj
INTEGER(i4)       :: lyr

REAL(r4), allocatable :: ival(:)
INTEGER(i4)       :: k

allocate(ival(ens%nmembers))

call ensInterp(ens,var,xi,yj,lyr,ival)
call com_mean(ens%nmembers,ival,ensmeanij)
deallocate(ival)

return
END FUNCTION

REAL(r4) FUNCTION ensvar(ens,var1,ptlon1,ptlat1,lyr1)
IMPLICIT NONE
!REAL(r4)          :: mlon(:,:)
!REAL(r4)          :: mlat(:,:)
TYPE(t_ens)       :: ens

CHARACTER(Len=*)  :: var1
REAL(r4)          :: ptlon1
REAL(r4)          :: ptlat1
INTEGER(i4)       :: lyr1

character(:),allocatable :: var

REAL(r4)          :: iindx
REAL(r4)          :: jindx
REAL(r4)          :: ival1(ens%nmembers)
INTEGER(i4)       :: k
! variable1
iindx=ridx(ens%enslon,ptlon1)
jindx=ridx(ens%enslat,ptlat1)

var="var2d"
iindx=ridx(ens%enslon,ptlon1)
jindx=ridx(ens%enslat,ptlat1)
call ensInterp(ens,var,iindx,jindx,lyr1,ival1)
! calculate covariance
call com_stdev(ens%nmembers,ival1,ensvar)
return
END FUNCTION

REAL(r4) FUNCTION enscovr(ens,var1,ptlon1,ptlat1,lyr1,var2,ptlon2,ptlat2,lyr2)
IMPLICIT NONE
!REAL(r4)          :: mlon(:,:)
!REAL(r4)          :: mlat(:,:)
TYPE(t_ens)       :: ens

CHARACTER(Len=*)  :: var1
REAL(r4)          :: ptlon1
REAL(r4)          :: ptlat1
INTEGER(i4)       :: lyr1

CHARACTER(Len=*)  :: var2
REAL(r4)          :: ptlon2
REAL(r4)          :: ptlat2
INTEGER(i4)       :: lyr2
character(:),allocatable :: var

REAL(r4)          :: iindx
REAL(r4)          :: jindx
REAL(r4)          :: ival1(ens%nmembers)
REAL(r4)          :: ival2(ens%nmembers)
!REAL(r4), allocatable :: ival1(:)
!REAL(r4), allocatable :: ival2(:)

INTEGER(i4)       :: k

!allocate(ival1(ens%nmembers))
!allocate(ival2(ens%nmembers))

! variable1
iindx=ridx(ens%enslon,ptlon1)
jindx=ridx(ens%enslat,ptlat1)

if(var1==var2) then
var="var2d"
iindx=ridx(ens%enslon,ptlon1)
jindx=ridx(ens%enslat,ptlat1)
call ensInterp(ens,var,iindx,jindx,lyr1,ival1)
iindx=ridx(ens%enslon,ptlon2)
jindx=ridx(ens%enslat,ptlat2)
call ensInterp(ens,var,iindx,jindx,lyr2,ival2)
else
var="var2d"
! variable1
iindx=ridx(ens%enslon,ptlon1)
jindx=ridx(ens%enslat,ptlat1)
call ensInterp(ens,var,iindx,jindx,lyr1,ival1)
var="var2d1"
iindx=ridx(ens%enslon,ptlon2)
jindx=ridx(ens%enslat,ptlat2)
call ensInterp(ens,var,iindx,jindx,lyr2,ival2)   
endif
! calculate covariance
call com_covar(ens%nmembers,ival1,ival2,enscovr)
return
END FUNCTION

REAL(r4) FUNCTION enscovrij(ens,var1,xi1,yj1,lyr1,var2,xi2,yj2,lyr2)
IMPLICIT NONE
TYPE(t_ens)       :: ens

CHARACTER(Len=*)  :: var1
REAL(r4)          :: xi1
REAL(r4)          :: yj1
INTEGER(i4)       :: lyr1

CHARACTER(Len=*)  :: var2
REAL(r4)          :: xi2
REAL(r4)          :: yj2
INTEGER(i4)       :: lyr2


REAL(r4)          :: ival1(ens%nmembers)
REAL(r4)          :: ival2(ens%nmembers)

character(:),allocatable :: var

!REAL(r4), allocatable :: ival1(:)
!REAL(r4), allocatable :: ival2(:)

INTEGER(i4)       :: k

!allocate(ival1(ens%nmembers))
!allocate(ival2(ens%nmembers))

if(var1==var2) then
var="var2d"        
call ensInterp(ens,var,xi1,yj1,lyr1,ival1)
! variable2
call ensInterp(ens,var,xi2,yj2,lyr2,ival2)
else
var="var2d"       
!print *, var,xi1,yj1,lyr1,ival1
call ensInterp(ens,var,xi1,yj1,lyr1,ival1)
var="var2d1"
!print *, var,xi2,yj2,lyr2,ival2
call ensInterp(ens,var,xi2,yj2,lyr2,ival2)
endif

! calculate covariance

call com_covar(ens%nmembers,ival1,ival2,enscovrij)
!deallocate(ival1,ival2)
return
END FUNCTION


SUBROUTINE ensInterp(ens,var,xi,yj,ik,ival)
USE mkinds

IMPLICIT NONE

TYPE(t_ens)               :: ens
CHARACTER(LEN=*)          :: var
REAL(r4),INTENT(IN)       :: xi
REAL(r4),INTENT(IN)       :: yj
INTEGER(i4),INTENT(IN)    :: ik
REAL(r4),INTENT(INOUT)    :: ival(:)

! local variables

INTEGER(i4)               :: ix,jy,k,l
REAL(r4)                  :: r,s,f,f1,f2,f3

!Assumes that all points comming in are on the grid -- needs error handling

!..ensure position is on the grid

     IF (xi .ge. real(2) .and. xi .le. real(ens%ens_nx-1) .and. yj .ge. real(2) .and. yj .le. real(ens%ens_ny-1)) THEN



     ix = int (xi)
     jy = int (yj)

     r = xi - real (ix)
     s = yj - real (jy)

IF(var=="var2d") then
! bilinear intp
IF (r==0. .and. s==0.) THEN
         DO k=1,ens%nmembers
         ival(k)=ens%var2d(ix,jy,k)
         ENDDO
         RETURN

         ELSE

         do k=1,ens%nmembers

         f  = ens%var2d(ix,jy,k)
         f1 = ens%var2d(ix+1,jy,k)
         f2 = ens%var2d(ix,jy+1,k)
         f3 = ens%var2d(ix+1,jy+1,k)

         ival(k) = (1. - s) * ((1. - r) * f + r * f1) + s * ((1. - r) * f2 + r * f3)
         enddo
 endif

ELSE If( var=="var2d1") then !var

        IF (r==0. .and. s==0.) THEN
         DO k=1,ens%nmembers
         ival(k)=ens%var2d1(ix,jy,k)
         ENDDO
         RETURN

         ELSE

         do k=1,ens%nmembers

         f  = ens%var2d1(ix,jy,k)
         f1 = ens%var2d1(ix+1,jy,k)
         f2 = ens%var2d1(ix,jy+1,k)
         f3 = ens%var2d1(ix+1,jy+1,k)

         ival(k) = (1. - s) * ((1. - r) * f + r * f1) + s * ((1. - r) * f2 + r * f3)
         enddo
 endif


ENDIF ! var


else
       ival=0.0

endif


end subroutine ensInterp

SUBROUTINE ensInterp_var(ens,var,xi,yj,ik,ival)
USE mkinds

IMPLICIT NONE

TYPE(t_ens)               :: ens
CHARACTER(LEN=*)          :: var
REAL(r4),INTENT(IN)       :: xi
REAL(r4),INTENT(IN)       :: yj
INTEGER(i4),INTENT(IN)    :: ik
REAL(r4),INTENT(INOUT)    :: ival(:)

! local variables

INTEGER(i4)               :: ix,jy,k,l
REAL(r4)                  :: r,s,f,f1,f2,f3

!Assumes that all points comming in are on the grid -- needs error handling

!..ensure position is on the grid

!     IF (xi .ge. real(2) .and. xi .le. real(ens%nx-1) .and. yj .ge. real(2) .and. yj .le. real(ens%ny-1)) THEN



     ix = int (xi)
     jy = int (yj)

     r = xi - real (ix)
     s = yj - real (jy)

! bilinear intp
SELECT CASE (var)

CASE ("ssh")

         IF (r==0. .and. s==0.) THEN
         DO k=1,ens%nmembers
         ival(k)=ens%ssh(ix,jy,k)
         ENDDO
         RETURN

         ELSE

do k=1,ens%nmembers

     f  = ens%ssh(ix,jy,k)
     f1 = ens%ssh(ix+1,jy,k)
     f2 = ens%ssh(ix,jy+1,k)
     f3 = ens%ssh(ix+1,jy+1,k)

     ival(k) = (1. - s) * ((1. - r) * f + r * f1) + s * ((1. - r) * f2 + r * f3)
!       fs(i) = (1. - s) * ((1. - r) * f(i) + r * f1(i)) + s * ((1. - r) * f2(i) + r *f3(i))
enddo
     !if(any(abs(ival)>1e10)) ival=0.0

return
endif

CASE("sst")

do k=1,ens%nmembers

     f  = ens%sst(ix,jy,k)
     f1 = ens%sst(ix+1,jy,k)
     f2 = ens%sst(ix,jy+1,k)
     f3 = ens%sst(ix+1,jy+1,k)

     ival(k) = (1. - s) * ((1. - r) * f + r * f1) + s * ((1. - r) * f2 + r * f3)

enddo

CASE ("uvl")

do k=1,ens%nmembers

     f  = ens%uvl(ix,jy,ik,k)
     f1 = ens%uvl(ix+1,jy,ik,k)
     f2 = ens%uvl(ix,jy+1,ik,k)
     f3 = ens%uvl(ix+1,jy+1,ik,k)

     ival(k) = (1. - s) * ((1. - r) * f + r * f1) + s * ((1. - r) * f2 + r * f3)
enddo

CASE("vvl")

do k=1,ens%nmembers

     f  = ens%vvl(ix,jy,ik,k)
     f1 = ens%vvl(ix+1,jy,ik,k)
     f2 = ens%vvl(ix,jy+1,ik,k)
     f3 = ens%vvl(ix+1,jy+1,ik,k)

     ival(k) = (1. - s) * ((1. - r) * f + r * f1) + s * ((1. - r) * f2 + r * f3)

enddo


CASE("tem")

do k=1,ens%nmembers

     f  = ens%var(ix,jy,ik,k)
     f1 = ens%var(ix+1,jy,ik,k)
     f2 = ens%var(ix,jy+1,ik,k)
     f3 = ens%var(ix+1,jy+1,ik,k)

     ival(k) = (1. - s) * ((1. - r) * f + r * f1) + s * ((1. - r) * f2 + r * f3)

enddo

CASE("sal")

do k=1,ens%nmembers

     f  = ens%var(ix,jy,ik,k)
     f1 = ens%var(ix+1,jy,ik,k)
     f2 = ens%var(ix,jy+1,ik,k)
     f3 = ens%var(ix+1,jy+1,ik,k)

     ival(k) = (1. - s) * ((1. - r) * f + r * f1) + s * ((1. - r) * f2 + r * f3)
enddo


CASE("den")

do k=1,ens%nmembers

     f  = ens%var(ix,jy,ik,k)
     f1 = ens%var(ix+1,jy,ik,k)
     f2 = ens%var(ix,jy+1,ik,k)
     f3 = ens%var(ix+1,jy+1,ik,k)

     ival(k) = (1. - s) * ((1. - r) * f + r * f1) + s * ((1. - r) * f2 + r * f3)
enddo

CASE("thk")

do k=1,ens%nmembers

     f  = ens%var(ix,jy,ik,k)
     f1 = ens%var(ix+1,jy,ik,k)
     f2 = ens%var(ix,jy+1,ik,k)
     f3 = ens%var(ix+1,jy+1,ik,k)

     ival(k) = (1. - s) * ((1. - r) * f + r * f1) + s * ((1. - r) * f2 + r * f3)
     
enddo


END SELECT

END SUBROUTINE ensInterp_var

SUBROUTINE com_mean(ndim,var,amean)
  IMPLICIT NONE

  INTEGER,INTENT(IN) :: ndim
  REAL(r4),INTENT(IN) :: var(ndim)
  REAL(r4),INTENT(OUT) :: amean

  INTEGER :: i

  amean = 0.0d0
  DO i=1,ndim
    amean = amean + var(i)
  END DO
  amean = amean / REAL(ndim,r4)

  RETURN
END SUBROUTINE com_mean
!-----------------------------------------------------------------------
! Standard deviation
!-----------------------------------------------------------------------
SUBROUTINE com_stdev(ndim,var,aout)
  IMPLICIT NONE

  INTEGER,INTENT(IN) :: ndim
  REAL(r4),INTENT(IN) :: var(ndim)
  REAL(r4),INTENT(OUT) :: aout

  REAL(r4) :: amean
  REAL(r4) :: dev(ndim)

  CALL com_mean(ndim,var,amean)

  dev(:) = var(:) - amean

  aout = SQRT( SUM(dev*dev) / REAL(ndim-1,r4) )

  RETURN
END SUBROUTINE com_stdev
!-----------------------------------------------------------------------
! Covariance
!-----------------------------------------------------------------------
SUBROUTINE com_covar(ndim,var1,var2,cov)
  IMPLICIT NONE

  INTEGER,INTENT(IN) :: ndim
  REAL(r4),INTENT(IN) :: var1(ndim)
  REAL(r4),INTENT(IN) :: var2(ndim)
  REAL(r4),INTENT(OUT) :: cov

  REAL(r4) :: amean1,amean2
  REAL(r4) :: dev1(ndim),dev2(ndim)

  CALL com_mean(ndim,var1,amean1)
  CALL com_mean(ndim,var2,amean2)

  dev1(:) = var1(:) - amean1
  dev2(:) = var2(:) - amean2

  cov = SUM( dev1*dev2 ) / REAL(ndim-1,r4)

  RETURN
END SUBROUTINE com_covar
!-----------------------------------------------------------------------
! Correlation
!-----------------------------------------------------------------------
SUBROUTINE com_correl(ndim,var1,var2,cor)
  IMPLICIT NONE

  INTEGER,INTENT(IN) :: ndim
  REAL(r4),INTENT(IN) :: var1(ndim)
  REAL(r4),INTENT(IN) :: var2(ndim)
  REAL(r4),INTENT(OUT) :: cor

  REAL(r4) :: cov,stdev1,stdev2

  CALL com_stdev(ndim,var1,stdev1)
  CALL com_stdev(ndim,var2,stdev2)
  CALL com_covar(ndim,var1,var2,cov)


  cor = cov/stdev1/stdev2
  RETURN
END SUBROUTINE com_correl


END MODULE
